package ex.id;

import blang.core.DeboxedName;
import blang.core.Distribution;
import blang.core.DistributionAdaptor;
import blang.core.ForwardSimulator;
import blang.core.LogScaleFactor;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.RealDistribution;
import blang.core.RealDistributionAdaptor;
import blang.core.RealVar;
import blang.core.UnivariateModel;
import blang.core.WritableRealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Random;

@SuppressWarnings("all")
public class ProductOfUnifs implements Model, UnivariateModel<RealVar>, ForwardSimulator {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public RealVar realization;
    
    private boolean realization_initialized = false;
    
    public ProductOfUnifs.Builder setRealization(final RealVar realization) {
      realization_initialized = true;
      this.realization = realization;
      return this;
    }
    
    public ProductOfUnifs build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      if (!fromCommandLine && !realization_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing realization");
      final RealVar __realization = realization;
      // Build the instance after boxing params
      return new ProductOfUnifs(
        __realization
      );
    }
  }
  
  @DesignatedConstructor
  public static ProductOfUnifs.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final RealVar realization;
  
  public RealVar getRealization() {
    return realization;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * { if (realization <= 0.0 || realization >= 1.0) return NEGATIVE_INFINITY return log(-log(realization)) }
   */
  private static double $generated__0(final RealVar realization) {
    if ((((realization).doubleValue() <= 0.0) || ((realization).doubleValue() >= 1.0))) {
      return StaticUtils.NEGATIVE_INFINITY();
    }
    double _log = Math.log((realization).doubleValue());
    double _minus = (-_log);
    return Math.log(_minus);
  }
  
  public static class $generated__0_class implements LogScaleFactor {
    public double logDensity() {
      return $generated__0(realization);
    }
    
    public String toString() {
      return "{ if (realization <= 0.0 || realization >= 1.0) return NEGATIVE_INFINITY return log(-log(realization)) }";
    }
    
    private final RealVar realization;
    
    public $generated__0_class(final RealVar realization) {
      this.realization = realization;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * { rnd.nextDouble * rnd.nextDouble }
   */
  private static Double $generated__1(final Random rnd, final RealVar realization) {
    double _nextDouble = rnd.nextDouble();
    double _nextDouble_1 = rnd.nextDouble();
    return Double.valueOf((_nextDouble * _nextDouble_1));
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public ProductOfUnifs(@DeboxedName("realization") final RealVar realization) {
    this.realization = realization;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: (realization) { if (realization <= 0.0 || realization >= 1.0) return NEGATIVE_INFINITY return log(-log(realization)) }
      // Construction and addition of the factor/model:
      components.add(
        new $generated__0_class(realization));
    }
    
    return components;
  }
  
  public void generate(final Random rnd) {
    ((WritableRealVar) realization).set(
      $generated__1(rnd, realization)
    );
  }
  
  public RealVar realization() {
    return realization;
  }
  
  /**
   * Returns an instance with fixed parameters values and conforming the Distribution interface. 
   * Useful when passing around distributions as parameters, e.g. for Dirichlet Process mixtures. 
   * 
   */
  public static RealDistribution distribution() {
    UnivariateModel<RealVar> univariateModel = new ProductOfUnifs(
      new RealDistributionAdaptor.WritableRealVarImpl()
    );
    Distribution<RealVar> distribution = new DistributionAdaptor(univariateModel);
    return new RealDistributionAdaptor(distribution);
  }
}
