package ex.id;

import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.IntScalar;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class Unid implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<RealVar> p1;
    
    public Unid.Builder setP1(final RealVar p1) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.p1 = Optional.of(p1);
      return this;
    }
    
    @Arg
    public Optional<RealVar> p2;
    
    public Unid.Builder setP2(final RealVar p2) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.p2 = Optional.of(p2);
      return this;
    }
    
    @Arg
    public Optional<IntVar> launch1;
    
    public Unid.Builder setLaunch1(final IntVar launch1) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.launch1 = Optional.of(launch1);
      return this;
    }
    
    @Arg
    public Optional<IntVar> launch2;
    
    public Unid.Builder setLaunch2(final IntVar launch2) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.launch2 = Optional.of(launch2);
      return this;
    }
    
    @Arg
    public Optional<IntVar> launch3;
    
    public Unid.Builder setLaunch3(final IntVar launch3) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.launch3 = Optional.of(launch3);
      return this;
    }
    
    @Arg
    public Optional<IntVar> nextLaunch;
    
    public Unid.Builder setNextLaunch(final IntVar nextLaunch) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.nextLaunch = Optional.of(nextLaunch);
      return this;
    }
    
    public Unid build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      RealVar p1;
      if (this.p1 != null && this.p1.isPresent()) {
        p1 = this.p1.get();
      } else {
        p1 = $generated__14();
      }
      final RealVar __p1 = p1;
      RealVar p2;
      if (this.p2 != null && this.p2.isPresent()) {
        p2 = this.p2.get();
      } else {
        p2 = $generated__15(p1);
      }
      final RealVar __p2 = p2;
      IntVar launch1;
      if (this.launch1 != null && this.launch1.isPresent()) {
        launch1 = this.launch1.get();
      } else {
        launch1 = $generated__16(p1, p2);
      }
      final IntVar __launch1 = launch1;
      IntVar launch2;
      if (this.launch2 != null && this.launch2.isPresent()) {
        launch2 = this.launch2.get();
      } else {
        launch2 = $generated__17(p1, p2, launch1);
      }
      final IntVar __launch2 = launch2;
      IntVar launch3;
      if (this.launch3 != null && this.launch3.isPresent()) {
        launch3 = this.launch3.get();
      } else {
        launch3 = $generated__18(p1, p2, launch1, launch2);
      }
      final IntVar __launch3 = launch3;
      IntVar nextLaunch;
      if (this.nextLaunch != null && this.nextLaunch.isPresent()) {
        nextLaunch = this.nextLaunch.get();
      } else {
        nextLaunch = $generated__19(p1, p2, launch1, launch2, launch3);
      }
      final IntVar __nextLaunch = nextLaunch;
      // Build the instance after boxing params
      return new Unid(
        __p1, 
        __p2, 
        __launch1, 
        __launch2, 
        __launch3, 
        __nextLaunch
      );
    }
  }
  
  @DesignatedConstructor
  public static Unid.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final RealVar p1;
  
  public RealVar getP1() {
    return p1;
  }
  
  private final RealVar p2;
  
  public RealVar getP2() {
    return p2;
  }
  
  private final IntVar launch1;
  
  public IntVar getLaunch1() {
    return launch1;
  }
  
  private final IntVar launch2;
  
  public IntVar getLaunch2() {
    return launch2;
  }
  
  private final IntVar launch3;
  
  public IntVar getLaunch3() {
    return launch3;
  }
  
  private final IntVar nextLaunch;
  
  public IntVar getNextLaunch() {
    return nextLaunch;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * launch1
   */
  private static IntVar $generated__0(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return launch1;
  }
  
  /**
   * Auxiliary method generated to translate:
   * p1 * p2
   */
  private static RealVar $generated__1(final RealVar p1, final RealVar p2) {
    return new blang.core.RealConstant(((p1).doubleValue() * (p2).doubleValue()));
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1(p1, p2);
    }
    
    public String toString() {
      return "p1 * p2";
    }
    
    private final RealVar p1;
    
    private final RealVar p2;
    
    public $generated__1_class(final RealVar p1, final RealVar p2) {
      this.p1 = p1;
      this.p2 = p2;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * launch2
   */
  private static IntVar $generated__2(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return launch2;
  }
  
  /**
   * Auxiliary method generated to translate:
   * p1 * p2
   */
  private static RealVar $generated__3(final RealVar p1, final RealVar p2) {
    return new blang.core.RealConstant(((p1).doubleValue() * (p2).doubleValue()));
  }
  
  public static class $generated__3_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__3(p1, p2);
    }
    
    public String toString() {
      return "p1 * p2";
    }
    
    private final RealVar p1;
    
    private final RealVar p2;
    
    public $generated__3_class(final RealVar p1, final RealVar p2) {
      this.p1 = p1;
      this.p2 = p2;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * launch3
   */
  private static IntVar $generated__4(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return launch3;
  }
  
  /**
   * Auxiliary method generated to translate:
   * p1 * p2
   */
  private static RealVar $generated__5(final RealVar p1, final RealVar p2) {
    return new blang.core.RealConstant(((p1).doubleValue() * (p2).doubleValue()));
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5(p1, p2);
    }
    
    public String toString() {
      return "p1 * p2";
    }
    
    private final RealVar p1;
    
    private final RealVar p2;
    
    public $generated__5_class(final RealVar p1, final RealVar p2) {
      this.p1 = p1;
      this.p2 = p2;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * nextLaunch
   */
  private static IntVar $generated__6(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return nextLaunch;
  }
  
  /**
   * Auxiliary method generated to translate:
   * p1 * p2
   */
  private static RealVar $generated__7(final RealVar p1, final RealVar p2) {
    return new blang.core.RealConstant(((p1).doubleValue() * (p2).doubleValue()));
  }
  
  public static class $generated__7_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__7(p1, p2);
    }
    
    public String toString() {
      return "p1 * p2";
    }
    
    private final RealVar p1;
    
    private final RealVar p2;
    
    public $generated__7_class(final RealVar p1, final RealVar p2) {
      this.p1 = p1;
      this.p2 = p2;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * p1
   */
  private static RealVar $generated__8(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return p1;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static RealVar $generated__9() {
    return new blang.core.RealConstant(0);
  }
  
  public static class $generated__9_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__9();
    }
    
    public String toString() {
      return "0";
    }
    
    public $generated__9_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1
   */
  private static RealVar $generated__10() {
    return new blang.core.RealConstant(1);
  }
  
  public static class $generated__10_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__10();
    }
    
    public String toString() {
      return "1";
    }
    
    public $generated__10_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * p2
   */
  private static RealVar $generated__11(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3, final IntVar nextLaunch) {
    return p2;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static RealVar $generated__12() {
    return new blang.core.RealConstant(0);
  }
  
  public static class $generated__12_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__12();
    }
    
    public String toString() {
      return "0";
    }
    
    public $generated__12_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 1
   */
  private static RealVar $generated__13() {
    return new blang.core.RealConstant(1);
  }
  
  public static class $generated__13_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__13();
    }
    
    public String toString() {
      return "1";
    }
    
    public $generated__13_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__14() {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__15(final RealVar p1) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static IntVar $generated__16(final RealVar p1, final RealVar p2) {
    return new blang.core.IntConstant(0);
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static IntVar $generated__17(final RealVar p1, final RealVar p2, final IntVar launch1) {
    return new blang.core.IntConstant(0);
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0
   */
  private static IntVar $generated__18(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2) {
    return new blang.core.IntConstant(0);
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__19(final RealVar p1, final RealVar p2, final IntVar launch1, final IntVar launch2, final IntVar launch3) {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public Unid(@DeboxedName("p1") final RealVar p1, @DeboxedName("p2") final RealVar p2, @DeboxedName("launch1") final IntVar launch1, @DeboxedName("launch2") final IntVar launch2, @DeboxedName("launch3") final IntVar launch3, @DeboxedName("nextLaunch") final IntVar nextLaunch) {
    this.p1 = p1;
    this.p2 = p2;
    this.launch1 = launch1;
    this.launch2 = launch2;
    this.launch3 = launch3;
    this.nextLaunch = nextLaunch;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: launch1 | p1, p2 ~ Bernoulli(p1 * p2)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__0(p1, p2, launch1, launch2, launch3, nextLaunch), 
          new $generated__1_class(p1, p2)
        )
        );
    }
    { // Code generated by: launch2 | p1, p2 ~ Bernoulli(p1 * p2)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__2(p1, p2, launch1, launch2, launch3, nextLaunch), 
          new $generated__3_class(p1, p2)
        )
        );
    }
    { // Code generated by: launch3 | p1, p2 ~ Bernoulli(p1 * p2)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__4(p1, p2, launch1, launch2, launch3, nextLaunch), 
          new $generated__5_class(p1, p2)
        )
        );
    }
    { // Code generated by: nextLaunch | p1, p2 ~ Bernoulli(p1 * p2)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__6(p1, p2, launch1, launch2, launch3, nextLaunch), 
          new $generated__7_class(p1, p2)
        )
        );
    }
    { // Code generated by: p1 ~ ContinuousUniform(0, 1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.ContinuousUniform(
          $generated__8(p1, p2, launch1, launch2, launch3, nextLaunch), 
          new $generated__9_class(), 
          new $generated__10_class()
        )
        );
    }
    { // Code generated by: p2 ~ ContinuousUniform(0, 1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.ContinuousUniform(
          $generated__11(p1, p2, launch1, launch2, launch3, nextLaunch), 
          new $generated__12_class(), 
          new $generated__13_class()
        )
        );
    }
    
    return components;
  }
}
