require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/id/results/all/Id--1636439421/samples/logDensity.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  1 
horizontalSize <- 4.0

n_samples <- max(data$sample)
cut_off <- n_samples * 0.5
data <- subset(data, sample > cut_off)

bacf <- acf(data$value, plot = FALSE)
bacfdf <- with(bacf, data.frame(lag, acf))

p <- ggplot(data = bacfdf, mapping = aes(x = lag, y = acf)) +
       xlab("Lag") +
       ylab("Autocorrelation") +
       ggtitle("Autocorrelation function for: logDensity") +
       geom_hline(aes(yintercept = 0)) +
       theme_bw() + 
       geom_segment(mapping = aes(xend = lag, yend = 0))
ggsave("/Users/bouchard/w/blogobayes/www/ex/id/results/all/Id--1636439421/autocorrelationFunctions/logDensity.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
