require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/id/results/all/Id--1636439421/samples/p.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  1 
horizontalSize <- 4.0

n_samples <- max(data$sample)
cut_off <- n_samples * 0.5
data <- subset(data, sample > cut_off)

p <- ggplot(data, aes(x = sample, y = value)) +
  geom_point(size = 0.1) + geom_line(alpha = 0.5) + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: p")
ggsave("/Users/bouchard/w/blogobayes/www/ex/id/results/all/Id--1636439421/tracePlots/p.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
