require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/id/results/all/Unid--1636439421/samples/nOutOfSupport.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  length(unique(data$chain)) 
horizontalSize <- 4.0

n_samples <- max(data$sample)
cut_off <- n_samples * 0.5
data <- subset(data, sample > cut_off)

p <- ggplot(data, aes(x = sample, y = value)) +
  geom_step() + facet_grid(chain ~ .
  , scales="free") + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: nOutOfSupport")
ggsave("/Users/bouchard/w/blogobayes/www/ex/id/results/all/Unid--1636439421/tracePlots/nOutOfSupport.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
